## level-zero 1.8.12

=== CMakeLists.txt ===
# Copyright (C) 2020-2021 Intel Corporation
# SPDX-License-Identifier: MIT

cmake_minimum_required(VERSION 3.2.0 FATAL_ERROR)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

if(MSVC AND (MSVC_VERSION LESS 1900))
    message(FATAL_ERROR "Visual Studio Compiler Version >= 1900 Required to build.")
endif()

# This project follows semantic versioning (https://semver.org/). Only set the
# major and minor version here - patch version is determined dynamically.
project(level-zero VERSION 1.8)

# Patch version corresponds to # of commits on master since last version
# major/minor tag (e.g., v1.0). If not building in a git repository, then get
# the patch version from a VERSION_PATCH file that would be shipped with a
# source distribution. Otherwise, use 0.
set(PROJECT_VERSION_PATCH 0)
find_package(Git)
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/VERSION_PATCH")
	file(READ "${CMAKE_CURRENT_SOURCE_DIR}/VERSION_PATCH" VERSION_PATCH)
	string(STRIP "${VERSION_PATCH}" PROJECT_VERSION_PATCH)
	message(STATUS "Using patch version from VERSION_PATCH file in source tree: ${PROJECT_VERSION_PATCH}")
elseif(Git_FOUND)
	if(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.git")
		message(WARNING "Cannot determine patch version - VERSION_PATCH file is not in source tree and source tree does not appear to be a git repository. Using 0 as patch version.")
		set(PROJECT_VERSION_PATCH 0)
	else()
		set(GIT_TAG "v${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}")
		if(MSVC)
			set(grep_string \\[CI\\] )
			execute_process(
				COMMAND CMD /c ${GIT_EXECUTABLE} rev-list ${GIT_TAG}..HEAD --grep=${grep_string} --invert-grep --count
				OUTPUT_VARIABLE VERSION_PATCH
				WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
			)
		else()
			set(grep_string "\\[CI\\] ")
			execute_process(
				COMMAND ${GIT_EXECUTABLE} rev-list ${GIT_TAG}..HEAD --grep=${grep_string} --invert-grep --count
				OUTPUT_VARIABLE VERSION_PATCH
				WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
			)
		endif()
		string(STRIP "${VERSION_PATCH}" PROJECT_VERSION_PATCH)
		if(PROJECT_VERSION_PATCH STREQUAL "")
			message(WARNING "Cannot determine patch version - couldn't find ${GIT_TAG} tag in repository. Using 0 as patch version.")
			set(PROJECT_VERSION_PATCH 0)
		else()
			message(STATUS "Using patch version from commit count in git repository: ${PROJECT_VERSION_PATCH}")
		endif()
	endif()
endif()

# Update other relevant variables to include the patch
set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
set(CMAKE_PROJECT_VERSION_PATCH "${PROJECT_VERSION_PATCH}")
set(CMAKE_PROJECT_VERSION "${PROJECT_VERSION}")
add_definitions(-DLOADER_VERSION_MAJOR=${PROJECT_VERSION_MAJOR})
add_definitions(-DLOADER_VERSION_MINOR=${PROJECT_VERSION_MINOR})
add_definitions(-DLOADER_VERSION_PATCH=${PROJECT_VERSION_PATCH})

file(WRITE "${CMAKE_BINARY_DIR}/VERSION" "${PROJECT_VERSION}")

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

#Define a path for custom commands to work around MSVC
set(CUSTOM_COMMAND_BINARY_DIR ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
if(MSVC)
    #MSVC implicitly adds $<CONFIG> to the output path
    set(CUSTOM_COMMAND_BINARY_DIR ${CUSTOM_COMMAND_BINARY_DIR}/$<CONFIG>)
    #enabling Control Flow Guard
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /guard:cf")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /guard:cf")
    # enable Spectre Mitigation
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Qspectre")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /Qspectre")
endif()

#CXX compiler support
if(NOT MSVC)
    include(CheckCXXCompilerFlag)
    CHECK_CXX_COMPILER_FLAG("-std=c++14" COMPILER_SUPPORTS_CXX14)
    if(COMPILER_SUPPORTS_CXX14)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
    else()
        message(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no C++14 support.  Please use a different C++ compiler.")
    endif()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive -fPIC")
endif()

#MSVC compile flags
if(MSVC)
    string(REPLACE "/MDd" "/MTd" CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}")
    string(REPLACE "/MD" "/MT" CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE}")

    # treat warnings as errors
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /WX /W3")

    # enable multi-process compilation
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")

    # enable exceptions handling
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc")
    
    # enable creation of PDB files for Release Builds
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /Zi")
    set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /DEBUG /OPT:REF /OPT:ICF")
		
    # enable CET shadow stack
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /CETCOMPAT")

    #Use of sccache with MSVC requires workaround of replacing /Zi with /Z7
    #https://github.com/mozilla/sccache
    if(USE_Z7) #sccache 
      string(REPLACE "/Zi" "/Z7" CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}")
      string(REPLACE "/Zi" "/Z7" CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG}")
      string(REPLACE "/Zi" "/Z7" CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE}")
      string(REPLACE "/Zi" "/Z7" CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE}")
      string(REPLACE "/Zi" "/Z7" CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")
      string(REPLACE "/Zi" "/Z7" CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO}")
    endif()

endif()

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/source/wrapper/include)

include_directories("${CMAKE_CURRENT_SOURCE_DIR}")

set(TARGET_LOADER_NAME ze_loader)


add_subdirectory(source)
add_subdirectory(samples)

include("os_release_info.cmake")
get_os_release_info(os_name os_version os_codename)
string(APPEND os_type "${os_name}")
string(COMPARE EQUAL "${os_type}" "sles" sles_distro)
#Pick only first character of os_name
string(SUBSTRING "${os_name}" 0 1 os_name)

file(GLOB LEVEL_ZERO_API_HEADERS "${CMAKE_CURRENT_SOURCE_DIR}/include/*.h")

install(FILES ${LEVEL_ZERO_API_HEADERS}
    DESTINATION ${CMAKE_INSTALL_PREFIX}/include/level_zero/
    COMPONENT level-zero-devel
)

file(GLOB LEVEL_ZERO_LAYERS_API_HEADERS "${CMAKE_CURRENT_SOURCE_DIR}/include/layers/*.h")

install(FILES ${LEVEL_ZERO_LAYERS_API_HEADERS}
    DESTINATION ${CMAKE_INSTALL_PREFIX}/include/level_zero/layers
    COMPONENT level-zero-devel
)

file(GLOB LEVEL_ZERO_LOADER_API_HEADERS "${CMAKE_CURRENT_SOURCE_DIR}/include/loader/*.h")

install(FILES ${LEVEL_ZERO_LOADER_API_HEADERS}
    DESTINATION ${CMAKE_INSTALL_PREFIX}/include/level_zero/loader
    COMPONENT level-zero-devel
)

# If generators list was not define build native package for current distro
if(NOT DEFINED CPACK_GENERATOR)
	if(EXISTS "/etc/debian_version")
		set(CPACK_GENERATOR "DEB")
	elseif(EXISTS "/etc/redhat-release")
		set(CPACK_GENERATOR "RPM")
	elseif(EXISTS "/etc/SUSE-brand" OR EXISTS "/etc/SUSE-release" OR sles_distro)
		set(CPACK_GENERATOR "RPM")
	else()
		set(CPACK_GENERATOR "ZIP")
	endif()
endif()

if(MSVC)
	set(CPACK_SET_DESTDIR FALSE)
	set(CPACK_PACKAGING_INSTALL_PREFIX "")
	install(DIRECTORY "${CMAKE_INSTALL_PREFIX}/include/" DESTINATION "include")
else()
	set(CPACK_SET_DESTDIR TRUE)
endif()
set(CPACK_PACKAGE_RELOCATABLE FALSE)
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "oneAPI Level Zero")
set(CPACK_PACKAGE_VENDOR "Intel")

set(CPACK_PACKAGE_INSTALL_DIRECTORY ${CMAKE_INSTALL_PREFIX})
set(CPACK_PACKAGE_CONTACT "Intel Corporation")

set(CPACK_PACKAGE_VERSION_MAJOR "${PROJECT_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${PROJECT_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${PROJECT_VERSION_PATCH}")

if(CPACK_GENERATOR MATCHES "RPM")
	set(CPACK_RPM_COMPRESSION_TYPE "xz")
	string(FIND "${CMAKE_CXX_COMPILER}" "aarch64" compiler_arch_check)
	if((NOT ${compiler_arch_check} MATCHES "-1") OR (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "aarch64"))
		set(CPACK_RPM_PACKAGE_ARCHITECTURE "aarch64")
	elseif(${CMAKE_SYSTEM_PROCESSOR} STREQUAL "x86_64")
		set(CPACK_RPM_PACKAGE_ARCHITECTURE "x86_64")
	endif()
	set(CPACK_RPM_PACKAGE_AUTOREQ OFF)
	set(CPACK_RPM_PACKAGE_DESCRIPTION "oneAPI Level Zero")
	set(CPACK_RPM_PACKAGE_GROUP "System Environment/Libraries")
	set(CPACK_RPM_PACKAGE_LICENSE "MIT")
	set(CPACK_RPM_PACKAGE_RELEASE 1)
	set(CPACK_RPM_PACKAGE_RELEASE_DIST ON)
	set(CPACK_RPM_PACKAGE_URL "https://github.com/oneapi-src/level-zero")
	set(CPACK_RPM_COMPONENT_INSTALL ON)
	set(CPACK_RPM_LEVEL-ZERO_PACKAGE_NAME "${PROJECT_NAME}")
	set(CPACK_RPM_LEVEL-ZERO-DEVEL_PACKAGE_NAME "${PROJECT_NAME}-devel")
	set(CPACK_RPM_LEVEL-ZERO_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION}-${os_name}${os_version}.${CPACK_RPM_PACKAGE_ARCHITECTURE}.rpm")
	set(CPACK_RPM_LEVEL-ZERO-DEVEL_FILE_NAME "${PROJECT_NAME}-devel-${PROJECT_VERSION}-${os_name}${os_version}.${CPACK_RPM_PACKAGE_ARCHITECTURE}.rpm")
	set(CPACK_RPM_LEVEL-ZERO-DEVEL_PACKAGE_REQUIRES "level-zero = ${PROJECT_VERSION}")


	set(CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION
	  /etc/ld.so.conf.d
	  /usr/local
	  /usr/local/lib64
	  /usr/local/bin
	  /usr/local/include
	)
endif()

if(CPACK_GENERATOR MATCHES "DEB")
	string(FIND "${CMAKE_CXX_COMPILER}" "aarch64" compiler_arch_check)
	if((NOT ${compiler_arch_check} MATCHES "-1") OR (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "aarch64"))
		SET(CPACK_DEBIAN_PACKAGE_ARCHITECTURE arm64)
	elseif(${CMAKE_SYSTEM_PROCESSOR} STREQUAL "x86_64")
		SET(CPACK_DEBIAN_PACKAGE_ARCHITECTURE amd64)
	endif()
	set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/oneapi-src/level-zero")
	set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
	set(CPACK_DEBIAN_LEVEL-ZERO_PACKAGE_NAME "${PROJECT_NAME}")
	set(CPACK_DEBIAN_LEVEL-ZERO-DEVEL_PACKAGE_NAME "${PROJECT_NAME}-devel")
    set(CPACK_DEBIAN_LEVEL-ZERO_FILE_NAME "${PROJECT_NAME}_${PROJECT_VERSION}+${os_name}${os_version}_${CPACK_DEBIAN_PACKAGE_ARCHITECTURE}.deb")
    set(CPACK_DEBIAN_LEVEL-ZERO-DEVEL_FILE_NAME "${PROJECT_NAME}-devel_${PROJECT_VERSION}+${os_name}${os_version}_${CPACK_DEBIAN_PACKAGE_ARCHITECTURE}.deb")
    set(CPACK_DEBIAN_LEVEL-ZERO-DEVEL_PACKAGE_DEPENDS "level-zero(=${PROJECT_VERSION})")
    set(CPACK_DEB_COMPONENT_INSTALL ON)
    set(CPACK_ARCHIVE_COMPONENT_INSTALL ON)
endif()

INCLUDE(CPack)

=== source/loader/CMakeLists.txt ===
# Copyright (C) 2020 Intel Corporation
# SPDX-License-Identifier: MIT


target_sources(${TARGET_LOADER_NAME}
    PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}/ze_object.h
        ${CMAKE_CURRENT_SOURCE_DIR}/ze_loader.h
        ${CMAKE_CURRENT_SOURCE_DIR}/ze_loader.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/ze_loader_api.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/ze_ldrddi.h
        ${CMAKE_CURRENT_SOURCE_DIR}/ze_ldrddi.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/zet_ldrddi.h
        ${CMAKE_CURRENT_SOURCE_DIR}/zet_ldrddi.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/zes_ldrddi.h
        ${CMAKE_CURRENT_SOURCE_DIR}/zes_ldrddi.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/zel_tracing_ldrddi.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/driver_discovery.h
)

if(WIN32)
    target_sources(${TARGET_LOADER_NAME}
        PRIVATE
            ${CMAKE_CURRENT_SOURCE_DIR}/windows/driver_discovery_win.cpp
            ${CMAKE_CURRENT_SOURCE_DIR}/windows/loader_init.cpp
    )
else()
    target_sources(${TARGET_LOADER_NAME}
        PRIVATE
            ${CMAKE_CURRENT_SOURCE_DIR}/linux/driver_discovery_lin.cpp
            ${CMAKE_CURRENT_SOURCE_DIR}/linux/loader_init.cpp
    )
endif()

=== source/drivers/null/CMakeLists.txt ===
set(TARGET_NAME ze_null)

add_library(${TARGET_NAME}
    SHARED
        ${CMAKE_CURRENT_SOURCE_DIR}/ze_null.h
        ${CMAKE_CURRENT_SOURCE_DIR}/ze_null.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/ze_nullddi.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/zet_nullddi.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/zes_nullddi.cpp
)

set_target_properties(${TARGET_NAME} PROPERTIES
    VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}"
    SOVERSION "${PROJECT_VERSION_MAJOR}"
)

target_include_directories(${TARGET_NAME}
    PUBLIC
        ${CMAKE_CURRENT_SOURCE_DIR}
)

if(UNIX)
    set(GCC_COVERAGE_COMPILE_FLAGS "-fvisibility=hidden -fvisibility-inlines-hidden -fno-strict-aliasing")
    set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} ${GCC_COVERAGE_COMPILE_FLAGS}")
endif()

=== source/layers/tracing/CMakeLists.txt ===
# Copyright (C) 2020 Intel Corporation
# SPDX-License-Identifier: MIT
set(TARGET_NAME ze_tracing_layer)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/ZeTracingLayerVersion.rc.in
    ${CMAKE_CURRENT_BINARY_DIR}/ZeTracingLayerVersion.rc
    @ONLY)

add_library(${TARGET_NAME}
    SHARED
        ${CMAKE_CURRENT_SOURCE_DIR}/ze_tracing_layer.h
        ${CMAKE_CURRENT_SOURCE_DIR}/tracing.h
        ${CMAKE_CURRENT_SOURCE_DIR}/tracing_imp.h
        ${CMAKE_CURRENT_SOURCE_DIR}/ze_tracing_layer.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/ze_trcddi.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/tracing_imp.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/ze_tracing.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/ze_tracing_cb_structs.h
        ${CMAKE_CURRENT_SOURCE_DIR}/ze_tracing_register_cb.cpp
        ${CMAKE_CURRENT_BINARY_DIR}/ZeTracingLayerVersion.rc
)

if(WIN32)
    target_sources(${TARGET_NAME}
        PRIVATE
            ${CMAKE_CURRENT_SOURCE_DIR}/windows/tracing_init.cpp
    )
else()
    target_sources(${TARGET_NAME}
        PRIVATE
            ${CMAKE_CURRENT_SOURCE_DIR}/linux/tracing_init.cpp
    )
endif()

target_include_directories(${TARGET_NAME}
    PUBLIC
        ${CMAKE_CURRENT_SOURCE_DIR}
)

if(UNIX)
    set(GCC_COVERAGE_COMPILE_FLAGS "-fvisibility=hidden -fvisibility-inlines-hidden")
    set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} ${GCC_COVERAGE_COMPILE_FLAGS}")
endif()

set_target_properties(${TARGET_NAME} PROPERTIES
    VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}"
    SOVERSION  "${PROJECT_VERSION_MAJOR}"
)

install(TARGETS ze_tracing_layer
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY
        DESTINATION ${CMAKE_INSTALL_LIBDIR}
        COMPONENT level-zero
        NAMELINK_SKIP
)

install(TARGETS ze_tracing_layer
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY
        DESTINATION ${CMAKE_INSTALL_LIBDIR}
        COMPONENT level-zero-devel
        NAMELINK_ONLY
)

=== source/layers/validation/CMakeLists.txt ===
# Copyright (C) 2020 Intel Corporation
# SPDX-License-Identifier: MIT
set(TARGET_NAME ze_validation_layer)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/ZeValidationLayerVersion.rc.in
    ${CMAKE_CURRENT_BINARY_DIR}/ZeValidationLayerVersion.rc
    @ONLY)

add_library(${TARGET_NAME}
    SHARED
        ${CMAKE_CURRENT_SOURCE_DIR}/ze_validation_layer.h
        ${CMAKE_CURRENT_SOURCE_DIR}/ze_validation_layer.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/ze_valddi.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/zet_valddi.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/zes_valddi.cpp
        ${CMAKE_CURRENT_BINARY_DIR}/ZeValidationLayerVersion.rc
)

target_include_directories(${TARGET_NAME}
    PUBLIC
        ${CMAKE_CURRENT_SOURCE_DIR}
)

if(UNIX)
    set(GCC_COVERAGE_COMPILE_FLAGS "-fvisibility=hidden -fvisibility-inlines-hidden")
    set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} ${GCC_COVERAGE_COMPILE_FLAGS}")
endif()

set_target_properties(${TARGET_NAME} PROPERTIES
    VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}"
    SOVERSION  "${PROJECT_VERSION_MAJOR}"
)

install(TARGETS ze_validation_layer
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY
        DESTINATION ${CMAKE_INSTALL_LIBDIR}
        COMPONENT level-zero
        NAMELINK_SKIP
)

install(TARGETS ze_validation_layer
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY
        DESTINATION ${CMAKE_INSTALL_LIBDIR}
        COMPONENT level-zero-devel
        NAMELINK_ONLY
)

=== debian/changelog ===
level-zero (1.8.12-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 10 Jan 2023 16:24:53 +0200

level-zero (1.8.8-1) unstable; urgency=medium

  * Initial release. (Closes: #1025760)

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 08 Dec 2022 19:50:39 +0200

=== debian/control ===
Source: level-zero
Section: libs
Priority: optional
Maintainer: Timo Aaltonen <tjaalton@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake
Standards-Version: 4.6.1
Homepage: https://github.com/oneapi-src/level-zero
Vcs-Browser: https://salsa.debian.org/debian/level-zero
Vcs-Git: https://salsa.debian.org/debian/level-zero.git

Package: libze-dev
Section: libdevel
Architecture: amd64
Multi-Arch: same
Depends:
 libze1 (= ${binary:Version}),
 ${misc:Depends},
Description: oneAPI Level Zero -- development files
 The oneAPI Level Zero (Level Zero) provides low-level direct-to-metal
 interfaces that are tailored to the devices in a oneAPI platform.
 Level Zero supports broader language features such as function pointers,
 virtual functions, unified memory, and I/O capabilities while also
 providing fine-grain explicit controls needed by higher-level runtime APIs.
 .
 This package provides the development environment for Level Zero.

Package: libze1
Architecture: amd64
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: oneAPI Level Zero -- share libraries
 The oneAPI Level Zero (Level Zero) provides low-level direct-to-metal
 interfaces that are tailored to the devices in a oneAPI platform.
 Level Zero supports broader language features such as function pointers,
 virtual functions, unified memory, and I/O capabilities while also
 providing fine-grain explicit controls needed by higher-level runtime APIs.
 .
 This package contains the shared libraries for Level Zero.

## level-zero 1.12.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 
 # This project follows semantic versioning (https://semver.org/). Only set the
 # major and minor version here - patch version is determined dynamically.
-project(level-zero VERSION 1.8)
+project(level-zero VERSION 1.12)
 
 # Patch version corresponds to # of commits on master since last version
 # major/minor tag (e.g., v1.0). If not building in a git repository, then get
@@ -91,7 +91,11 @@
     else()
         message(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no C++14 support.  Please use a different C++ compiler.")
     endif()
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive -fPIC")
+    if (UNIX)
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive -fPIC")
+    else()
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive")
+    endif()
 endif()
 
 #MSVC compile flags

=== debian/changelog ===
level-zero (1.12.0-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 19 Jun 2023 16:03:51 +0300

level-zero (1.10.0-1) experimental; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 14 Apr 2023 21:33:07 +0300

## level-zero 1.13.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 
 # This project follows semantic versioning (https://semver.org/). Only set the
 # major and minor version here - patch version is determined dynamically.
-project(level-zero VERSION 1.12)
+project(level-zero VERSION 1.13)
 
 # Patch version corresponds to # of commits on master since last version
 # major/minor tag (e.g., v1.0). If not building in a git repository, then get

=== source/layers/validation/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (C) 2020 Intel Corporation
+# Copyright (C) 2020-2023 Intel Corporation
 # SPDX-License-Identifier: MIT
 set(TARGET_NAME ze_validation_layer)
 
@@ -20,6 +20,9 @@
 target_include_directories(${TARGET_NAME}
     PUBLIC
         ${CMAKE_CURRENT_SOURCE_DIR}
+        ${CMAKE_CURRENT_SOURCE_DIR}/common
+        ${CMAKE_CURRENT_SOURCE_DIR}/handle_lifetime_tracking
+        ${CMAKE_CURRENT_SOURCE_DIR}/parameter_validation
 )
 
 if(UNIX)
@@ -48,3 +51,5 @@
         NAMELINK_ONLY
 )
 
+add_subdirectory(parameter_validation)
+add_subdirectory(handle_lifetime_tracking)

=== source/layers/validation/parameter_validation/CMakeLists.txt ===
target_sources(${TARGET_NAME} 
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/param_validation.h
        ${CMAKE_CURRENT_LIST_DIR}/ze_parameter_validation.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ze_parameter_validation.h
        ${CMAKE_CURRENT_LIST_DIR}/zes_parameter_validation.cpp
        ${CMAKE_CURRENT_LIST_DIR}/zes_parameter_validation.h
        ${CMAKE_CURRENT_LIST_DIR}/zet_parameter_validation.cpp    
        ${CMAKE_CURRENT_LIST_DIR}/zet_parameter_validation.h
)

=== debian/changelog ===
level-zero (1.13.5-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 15 Sep 2023 10:52:01 +0300

## level-zero 1.16.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (C) 2020-2021 Intel Corporation
+# Copyright (C) 2020-2024 Intel Corporation
 # SPDX-License-Identifier: MIT
 
 cmake_minimum_required(VERSION 3.2.0 FATAL_ERROR)
@@ -12,7 +12,7 @@
 
 # This project follows semantic versioning (https://semver.org/). Only set the
 # major and minor version here - patch version is determined dynamically.
-project(level-zero VERSION 1.13)
+project(level-zero VERSION 1.16)
 
 # Patch version corresponds to # of commits on master since last version
 # major/minor tag (e.g., v1.0). If not building in a git repository, then get
@@ -77,9 +77,17 @@
     #enabling Control Flow Guard
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /guard:cf")
     set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /guard:cf")
-    # enable Spectre Mitigation
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Qspectre")
-    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /Qspectre")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /DYNAMICBASE")
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /DYNAMICBASE")
+    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /DYNAMICBASE")
+    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /guard:cf")
+    # enable Spectre Mitigation, not supported by clang-cl
+    if(NOT CMAKE_CXX_COMPILER_ID STREQUAL Clang)
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Qspectre")
+    endif()
+    if(NOT CMAKE_C_COMPILER_ID STREQUAL Clang)
+        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /Qspectre")
+    endif()
 endif()
 
 #CXX compiler support
@@ -96,6 +104,7 @@
     else()
         set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive")
     endif()
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Werror -Wnon-virtual-dtor")
 endif()
 
 #MSVC compile flags
@@ -106,8 +115,10 @@
     # treat warnings as errors
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /WX /W3")
 
-    # enable multi-process compilation
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
+    # enable multi-process compilation, not supported by clang-cl
+    if(NOT CMAKE_CXX_COMPILER_ID STREQUAL Clang)
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
+    endif()
 
     # enable exceptions handling
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc")
@@ -142,6 +153,10 @@
 
 add_subdirectory(source)
 add_subdirectory(samples)
+
+if(BUILD_L0_LOADER_TESTS)
+	add_subdirectory(test)
+endif()
 
 include("os_release_info.cmake")
 get_os_release_info(os_name os_version os_codename)

=== source/CMakeLists.txt ===
# Copyright (C) 2020 Intel Corporation
# SPDX-License-Identifier: MIT

add_definitions(-DL0_LOADER_VERSION="${PROJECT_VERSION_MAJOR}")
add_definitions(-DL0_VALIDATION_LAYER_SUPPORTED_VERSION="${PROJECT_VERSION_MAJOR}")

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/inc)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/ZeLoaderVersion.rc.in
    ${CMAKE_CURRENT_BINARY_DIR}/ZeLoaderVersion.rc
    @ONLY)

include(GNUInstallDirs)
add_library(${TARGET_LOADER_NAME}
    SHARED
    ""
    ${CMAKE_CURRENT_BINARY_DIR}/ZeLoaderVersion.rc
)

add_subdirectory(lib)
add_subdirectory(loader)
add_subdirectory(layers)
add_subdirectory(drivers)

set_target_properties(${TARGET_LOADER_NAME} PROPERTIES
    VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}"
    SOVERSION "${PROJECT_VERSION_MAJOR}"
)

target_link_libraries(${TARGET_LOADER_NAME}
    ${CMAKE_DL_LIBS}
)

if (UNIX)
    set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
    set(THREADS_PREFER_PTHREAD_FLAG TRUE)
    find_package(Threads REQUIRED)
    target_link_libraries (${TARGET_LOADER_NAME} Threads::Threads)
endif()

if(WIN32)
    target_link_libraries (${TARGET_LOADER_NAME} cfgmgr32.lib)
endif()

install(TARGETS ze_loader
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY
        DESTINATION ${CMAKE_INSTALL_LIBDIR}
        COMPONENT level-zero
        NAMELINK_SKIP
)

install(TARGETS ze_loader
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY
        DESTINATION ${CMAKE_INSTALL_LIBDIR}
        COMPONENT level-zero-devel
        NAMELINK_ONLY
)

if(UNIX)
    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/libze_loader.pc.in
        ${CMAKE_CURRENT_BINARY_DIR}/libze_loader.pc
        @ONLY)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libze_loader.pc" DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig" COMPONENT level-zero-devel)
    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/level-zero.pc.in
        ${CMAKE_CURRENT_BINARY_DIR}/level-zero.pc
        @ONLY)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/level-zero.pc" DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig" COMPONENT level-zero-devel)
endif()

=== test/CMakeLists.txt ===
# Copyright (C) 2024 Intel Corporation
# SPDX-License-Identifier: MIT
add_subdirectory(layers)
add_subdirectory(test_api)

=== samples/zello_world/CMakeLists.txt ===
set(TARGET_NAME zello_world)

add_executable(${TARGET_NAME}
    ${CMAKE_CURRENT_SOURCE_DIR}/zello_world.cpp
)
    
if(MSVC)
    set_target_properties(${TARGET_NAME}
        PROPERTIES
            VS_DEBUGGER_COMMAND_ARGUMENTS ""
            VS_DEBUGGER_WORKING_DIRECTORY "$(OutDir)"
    )
endif()

target_link_libraries(${TARGET_NAME}
    ${TARGET_LOADER_NAME}
    ${CMAKE_DL_LIBS}
)

=== test/layers/CMakeLists.txt ===
# Copyright (C) 2024 Intel Corporation
# SPDX-License-Identifier: MIT
add_subdirectory(validation)

=== test/test_api/CMakeLists.txt ===
# Copyright (C) 2024 Intel Corporation
# SPDX-License-Identifier: MIT

# function(add_test)

# endfunction()

# add_loader_test(
#   NAME test_loader_api
#   GROUP "/layer_tests/loader_api"
#   SOURCES
#     src/test_loader_api.cpp
#     src/main.cpp
#   LINK_LIBRARIES
#     level_zero_tests::logging
#     level_zero_tests::utils
# )

=== source/drivers/null/CMakeLists.txt ===
--- 
+++ 
@@ -19,6 +19,24 @@
         ${CMAKE_CURRENT_SOURCE_DIR}
 )
 
+if(INSTALL_NULL_DRIVER)
+    install(TARGETS ze_null
+        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+        LIBRARY
+            DESTINATION ${CMAKE_INSTALL_LIBDIR}
+            COMPONENT level-zero
+            NAMELINK_SKIP
+    )
+    install(TARGETS ze_null
+    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+    LIBRARY
+        DESTINATION ${CMAKE_INSTALL_LIBDIR}
+        COMPONENT level-zero-devel
+        NAMELINK_ONLY
+    )
+endif()
+
+
 if(UNIX)
     set(GCC_COVERAGE_COMPILE_FLAGS "-fvisibility=hidden -fvisibility-inlines-hidden -fno-strict-aliasing")
     set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} ${GCC_COVERAGE_COMPILE_FLAGS}")

=== source/layers/tracing/CMakeLists.txt ===
--- 
+++ 
@@ -50,6 +50,7 @@
 
 install(TARGETS ze_tracing_layer
     ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+    RUNTIME DESTINATION ${CMAKE_INSTALL_LIBDIR}
     LIBRARY
         DESTINATION ${CMAKE_INSTALL_LIBDIR}
         COMPONENT level-zero
@@ -58,6 +59,7 @@
 
 install(TARGETS ze_tracing_layer
     ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+    RUNTIME DESTINATION ${CMAKE_INSTALL_LIBDIR}
     LIBRARY
         DESTINATION ${CMAKE_INSTALL_LIBDIR}
         COMPONENT level-zero-devel

=== test/layers/validation/CMakeLists.txt ===
# Copyright (C) 2024 Intel Corporation
# SPDX-License-Identifier: MIT
add_subdirectory(handle_lifetime_tracking)

=== test/layers/validation/handle_lifetime_tracking/CMakeLists.txt ===
# Copyright (C) 2024 Intel Corporation
# SPDX-License-Identifier: MIT

=== debian/changelog ===
level-zero (1.16.1-1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:40:37 +0000

level-zero (1.16.1-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 26 Feb 2024 12:13:38 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: level-zero
 Section: libs
 Priority: optional
-Maintainer: Timo Aaltonen <tjaalton@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Timo Aaltonen <tjaalton@debian.org>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),

## level-zero 1.17.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,12 +7,14 @@
 set(CMAKE_CXX_EXTENSIONS OFF)
 
 if(MSVC AND (MSVC_VERSION LESS 1900))
-    message(FATAL_ERROR "Visual Studio Compiler Version >= 1900 Required to build.")
+message(FATAL_ERROR "Visual Studio Compiler Version >= 1900 Required to build.")
 endif()
 
 # This project follows semantic versioning (https://semver.org/). Only set the
 # major and minor version here - patch version is determined dynamically.
-project(level-zero VERSION 1.16)
+project(level-zero VERSION 1.17)
+
+include(GNUInstallDirs)
 
 # Patch version corresponds to # of commits on master since last version
 # major/minor tag (e.g., v1.0). If not building in a git repository, then get
@@ -55,6 +57,29 @@
 	endif()
 endif()
 
+if(Git_FOUND)
+	if(MSVC)
+		execute_process(
+			COMMAND CMD /c ${GIT_EXECUTABLE} rev-parse HEAD
+			OUTPUT_VARIABLE VERSION_SHA
+			OUTPUT_STRIP_TRAILING_WHITESPACE
+			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+		)
+	else()
+	execute_process(
+		COMMAND ${GIT_EXECUTABLE} rev-parse HEAD
+		OUTPUT_VARIABLE VERSION_SHA
+		OUTPUT_STRIP_TRAILING_WHITESPACE
+		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+	)
+	endif()
+else()
+	set(VERSION_SHA " - No git SHA found, compiled outside git folder.")
+endif()
+add_definitions(-DLOADER_VERSION_SHA="${VERSION_SHA}")
+
+include_directories("${CMAKE_CURRENT_SOURCE_DIR}/third_party/spdlog_headers")
+
 # Update other relevant variables to include the patch
 set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
 set(CMAKE_PROJECT_VERSION_PATCH "${PROJECT_VERSION_PATCH}")
@@ -82,10 +107,10 @@
     set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /DYNAMICBASE")
     set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /guard:cf")
     # enable Spectre Mitigation, not supported by clang-cl
-    if(NOT CMAKE_CXX_COMPILER_ID STREQUAL Clang)
+    if((NOT CMAKE_CXX_COMPILER_ID STREQUAL Clang) AND (NOT CMAKE_CXX_COMPILER_ID STREQUAL IntelLLVM))
         set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Qspectre")
     endif()
-    if(NOT CMAKE_C_COMPILER_ID STREQUAL Clang)
+    if((NOT CMAKE_C_COMPILER_ID STREQUAL Clang) AND NOT (CMAKE_C_COMPILER_ID STREQUAL IntelLLVM))
         set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /Qspectre")
     endif()
 endif()
@@ -104,7 +129,9 @@
     else()
         set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive")
     endif()
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Werror -Wnon-virtual-dtor")
+    if(NOT CMAKE_CXX_COMPILER_ID STREQUAL IntelLLVM)
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Werror -Wnon-virtual-dtor")
+    endif()
 endif()
 
 #MSVC compile flags
@@ -112,11 +139,13 @@
     string(REPLACE "/MDd" "/MTd" CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}")
     string(REPLACE "/MD" "/MT" CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE}")
 
-    # treat warnings as errors
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /WX /W3")
+    if(NOT CMAKE_CXX_COMPILER_ID STREQUAL IntelLLVM)
+        # treat warnings as errors
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /WX /W3")
+    endif()
 
     # enable multi-process compilation, not supported by clang-cl
-    if(NOT CMAKE_CXX_COMPILER_ID STREQUAL Clang)
+    if((NOT CMAKE_CXX_COMPILER_ID STREQUAL Clang) AND (NOT CMAKE_CXX_COMPILER_ID STREQUAL IntelLLVM))
         set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
     endif()
 
@@ -143,8 +172,21 @@
 
 endif()
 
+if(USE_ASAN)
+    if(NOT MSVC)
+        # -fno-omit-frame-pointer is included for nicer stack traces in error messages
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
+        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
+        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=address")
+        set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fsanitize=address")
+    else()
+        message(WARNING "Address Sanitizer is not supported on Windows")
+    endif()
+endif()
+
 include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
 include_directories(${CMAKE_CURRENT_SOURCE_DIR}/source/wrapper/include)
+
 
 include_directories("${CMAKE_CURRENT_SOURCE_DIR}")
 
@@ -168,21 +210,21 @@
 file(GLOB LEVEL_ZERO_API_HEADERS "${CMAKE_CURRENT_SOURCE_DIR}/include/*.h")
 
 install(FILES ${LEVEL_ZERO_API_HEADERS}
-    DESTINATION ${CMAKE_INSTALL_PREFIX}/include/level_zero/
+    DESTINATION ./include/level_zero
     COMPONENT level-zero-devel
 )
 
 file(GLOB LEVEL_ZERO_LAYERS_API_HEADERS "${CMAKE_CURRENT_SOURCE_DIR}/include/layers/*.h")
 
 install(FILES ${LEVEL_ZERO_LAYERS_API_HEADERS}
-    DESTINATION ${CMAKE_INSTALL_PREFIX}/include/level_zero/layers
+    DESTINATION ./include/level_zero/layers
     COMPONENT level-zero-devel
 )
 
 file(GLOB LEVEL_ZERO_LOADER_API_HEADERS "${CMAKE_CURRENT_SOURCE_DIR}/include/loader/*.h")
 
 install(FILES ${LEVEL_ZERO_LOADER_API_HEADERS}
-    DESTINATION ${CMAKE_INSTALL_PREFIX}/include/level_zero/loader
+    DESTINATION ./include/level_zero/loader
     COMPONENT level-zero-devel
 )
 
@@ -202,7 +244,6 @@
 if(MSVC)
 	set(CPACK_SET_DESTDIR FALSE)
 	set(CPACK_PACKAGING_INSTALL_PREFIX "")
-	install(DIRECTORY "${CMAKE_INSTALL_PREFIX}/include/" DESTINATION "include")
 else()
 	set(CPACK_SET_DESTDIR TRUE)
 endif()
@@ -260,11 +301,3 @@
 	set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
 	set(CPACK_DEBIAN_LEVEL-ZERO_PACKAGE_NAME "${PROJECT_NAME}")
 	set(CPACK_DEBIAN_LEVEL-ZERO-DEVEL_PACKAGE_NAME "${PROJECT_NAME}-devel")
-    set(CPACK_DEBIAN_LEVEL-ZERO_FILE_NAME "${PROJECT_NAME}_${PROJECT_VERSION}+${os_name}${os_version}_${CPACK_DEBIAN_PACKAGE_ARCHITECTURE}.deb")
-    set(CPACK_DEBIAN_LEVEL-ZERO-DEVEL_FILE_NAME "${PROJECT_NAME}-devel_${PROJECT_VERSION}+${os_name}${os_version}_${CPACK_DEBIAN_PACKAGE_ARCHITECTURE}.deb")
-    set(CPACK_DEBIAN_LEVEL-ZERO-DEVEL_PACKAGE_DEPENDS "level-zero(=${PROJECT_VERSION})")
-    set(CPACK_DEB_COMPONENT_INSTALL ON)
-    set(CPACK_ARCHIVE_COMPONENT_INSTALL ON)
-endif()
-
-INCLUDE(CPack)

=== source/CMakeLists.txt ===
--- 
+++ 
@@ -22,6 +22,8 @@
 add_subdirectory(loader)
 add_subdirectory(layers)
 add_subdirectory(drivers)
+add_subdirectory(utils)
+target_include_directories(${TARGET_LOADER_NAME} PRIVATE utils)
 
 set_target_properties(${TARGET_LOADER_NAME} PROPERTIES
     VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}"
@@ -42,6 +44,9 @@
 if(WIN32)
     target_link_libraries (${TARGET_LOADER_NAME} cfgmgr32.lib)
 endif()
+
+# Link against utility sublibrary
+target_link_libraries(${TARGET_LOADER_NAME} utils)
 
 install(TARGETS ze_loader
     ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}

=== source/utils/CMakeLists.txt ===
# Copyright (C) 2024 Intel Corporation
# SPDX-License-Identifier: MIT

add_library(utils
  STATIC
  "logging.h"
  "logging.cpp"
)

target_include_directories(utils PRIVATE ${CMAKE_SOURCE_DIR}/third_party/spdlog_headers/)

=== debian/changelog ===
level-zero (1.17.6-1) unstable; urgency=medium

  * New upstream release.
  * control: Add libspdlog-dev to build-depends.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 27 Jun 2024 12:25:10 +0300

## level-zero 1.17.39

=== CMakeLists.txt ===
--- 
+++ 
@@ -78,7 +78,32 @@
 endif()
 add_definitions(-DLOADER_VERSION_SHA="${VERSION_SHA}")
 
-include_directories("${CMAKE_CURRENT_SOURCE_DIR}/third_party/spdlog_headers")
+if(SYSTEM_SPDLOG)
+	find_package(spdlog CONFIG)
+	if(spdlog_FOUND)
+		message(STATUS "System spdlog found.")
+	else()
+		message(FATAL_ERROR "SYSTEM_SPDLOG specified but spdlog wasn't found.")
+	endif()
+else()
+    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/third_party/spdlog_headers")
+endif()
+
+include(FetchContent)
+
+if(BUILD_L0_LOADER_TESTS)
+	FetchContent_Declare(
+		googletest
+		URL https://github.com/google/googletest/archive/refs/tags/v1.14.0.zip
+	)
+
+	# For Windows: Prevent overriding the parent project's compiler/linker settings
+	set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
+
+	FetchContent_MakeAvailable(googletest)
+
+	enable_testing()
+endif()
 
 # Update other relevant variables to include the patch
 set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
@@ -151,17 +176,17 @@
 
     # enable exceptions handling
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc")
-    
+
     # enable creation of PDB files for Release Builds
     set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /Zi")
     set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /DEBUG /OPT:REF /OPT:ICF")
-		
+
     # enable CET shadow stack
     set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /CETCOMPAT")
 
     #Use of sccache with MSVC requires workaround of replacing /Zi with /Z7
     #https://github.com/mozilla/sccache
-    if(USE_Z7) #sccache 
+    if(USE_Z7) #sccache
       string(REPLACE "/Zi" "/Z7" CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}")
       string(REPLACE "/Zi" "/Z7" CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG}")
       string(REPLACE "/Zi" "/Z7" CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE}")
@@ -197,7 +222,8 @@
 add_subdirectory(samples)
 
 if(BUILD_L0_LOADER_TESTS)
-	add_subdirectory(test)
+    include(CTest)
+    add_subdirectory(test)
 endif()
 
 include("os_release_info.cmake")
@@ -290,14 +316,3 @@
 	)
 endif()
 
-if(CPACK_GENERATOR MATCHES "DEB")
-	string(FIND "${CMAKE_CXX_COMPILER}" "aarch64" compiler_arch_check)
-	if((NOT ${compiler_arch_check} MATCHES "-1") OR (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "aarch64"))
-		SET(CPACK_DEBIAN_PACKAGE_ARCHITECTURE arm64)
-	elseif(${CMAKE_SYSTEM_PROCESSOR} STREQUAL "x86_64")
-		SET(CPACK_DEBIAN_PACKAGE_ARCHITECTURE amd64)
-	endif()
-	set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/oneapi-src/level-zero")
-	set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
-	set(CPACK_DEBIAN_LEVEL-ZERO_PACKAGE_NAME "${PROJECT_NAME}")
-	set(CPACK_DEBIAN_LEVEL-ZERO-DEVEL_PACKAGE_NAME "${PROJECT_NAME}-devel")

=== test/CMakeLists.txt ===
# Copyright (C) 2024 Intel Corporation
# SPDX-License-Identifier: MIT

add_executable(
  tests
  loader_api.cpp
)
target_include_directories(tests PRIVATE ${CMAKE_SOURCE_DIR}/include)
target_link_libraries(
  tests
  GTest::gtest_main
  ${TARGET_LOADER_NAME}
)

# For some reason the MSVC runtime libraries used by googletest and test
# binaries don't match, so force the test binary to use the dynamic runtime.
if(MSVC)
    target_compile_options(tests PRIVATE "/MD$<$<CONFIG:Debug>:d>")
endif()

add_test(NAME tests COMMAND tests)
set_property(TEST tests PROPERTY ENVIRONMENT "ZE_ENABLE_NULL_DRIVER=1")

=== source/utils/CMakeLists.txt ===
# Copyright (C) 2024 Intel Corporation
# SPDX-License-Identifier: MIT

set(logging_files logging.h logging.cpp)
add_library(utils STATIC ${logging_files})

if(SYSTEM_SPDLOG)
       target_link_libraries(utils PUBLIC spdlog::spdlog)
else()
       target_include_directories(utils PUBLIC ${PROJECT_SOURCE_DIR}/third_party/spdlog_headers/)
endif()
set_property(TARGET utils PROPERTY POSITION_INDEPENDENT_CODE ON)

=== source/layers/validation/checkers/CMakeLists.txt ===
add_subdirectory(parameter_validation)
add_subdirectory(template)

=== debian/changelog ===
level-zero (1.17.39-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 04 Sep 2024 22:01:12 +0300

## level-zero 1.17.42

=== source/CMakeLists.txt ===
--- 
+++ 
@@ -49,21 +49,10 @@
 target_link_libraries(${TARGET_LOADER_NAME} utils)
 
 install(TARGETS ze_loader
-    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
-    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
-    LIBRARY
-        DESTINATION ${CMAKE_INSTALL_LIBDIR}
-        COMPONENT level-zero
-        NAMELINK_SKIP
-)
-
-install(TARGETS ze_loader
-    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
-    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
-    LIBRARY
-        DESTINATION ${CMAKE_INSTALL_LIBDIR}
-        COMPONENT level-zero-devel
-        NAMELINK_ONLY
+    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT level-zero-devel
+    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT level-zero
+    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT level-zero
+    NAMELINK_COMPONENT level-zero-devel
 )
 
 if(UNIX)

=== debian/changelog ===
level-zero (1.17.42-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Sat, 07 Sep 2024 10:25:04 +0300

## level-zero 1.19.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,62 +1,23 @@
 # Copyright (C) 2020-2024 Intel Corporation
 # SPDX-License-Identifier: MIT
 
-cmake_minimum_required(VERSION 3.2.0 FATAL_ERROR)
+cmake_minimum_required(VERSION 3.12.0 FATAL_ERROR)
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
 
+set(THIRD_PARTY_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/third_party)
+
 if(MSVC AND (MSVC_VERSION LESS 1900))
 message(FATAL_ERROR "Visual Studio Compiler Version >= 1900 Required to build.")
 endif()
 
-# This project follows semantic versioning (https://semver.org/). Only set the
-# major and minor version here - patch version is determined dynamically.
-project(level-zero VERSION 1.17)
+# This project follows semantic versioning (https://semver.org/)
+project(level-zero VERSION 1.19.2)
 
 include(GNUInstallDirs)
 
-# Patch version corresponds to # of commits on master since last version
-# major/minor tag (e.g., v1.0). If not building in a git repository, then get
-# the patch version from a VERSION_PATCH file that would be shipped with a
-# source distribution. Otherwise, use 0.
-set(PROJECT_VERSION_PATCH 0)
 find_package(Git)
-if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/VERSION_PATCH")
-	file(READ "${CMAKE_CURRENT_SOURCE_DIR}/VERSION_PATCH" VERSION_PATCH)
-	string(STRIP "${VERSION_PATCH}" PROJECT_VERSION_PATCH)
-	message(STATUS "Using patch version from VERSION_PATCH file in source tree: ${PROJECT_VERSION_PATCH}")
-elseif(Git_FOUND)
-	if(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.git")
-		message(WARNING "Cannot determine patch version - VERSION_PATCH file is not in source tree and source tree does not appear to be a git repository. Using 0 as patch version.")
-		set(PROJECT_VERSION_PATCH 0)
-	else()
-		set(GIT_TAG "v${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}")
-		if(MSVC)
-			set(grep_string \\[CI\\] )
-			execute_process(
-				COMMAND CMD /c ${GIT_EXECUTABLE} rev-list ${GIT_TAG}..HEAD --grep=${grep_string} --invert-grep --count
-				OUTPUT_VARIABLE VERSION_PATCH
-				WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
-			)
-		else()
-			set(grep_string "\\[CI\\] ")
-			execute_process(
-				COMMAND ${GIT_EXECUTABLE} rev-list ${GIT_TAG}..HEAD --grep=${grep_string} --invert-grep --count
-				OUTPUT_VARIABLE VERSION_PATCH
-				WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
-			)
-		endif()
-		string(STRIP "${VERSION_PATCH}" PROJECT_VERSION_PATCH)
-		if(PROJECT_VERSION_PATCH STREQUAL "")
-			message(WARNING "Cannot determine patch version - couldn't find ${GIT_TAG} tag in repository. Using 0 as patch version.")
-			set(PROJECT_VERSION_PATCH 0)
-		else()
-			message(STATUS "Using patch version from commit count in git repository: ${PROJECT_VERSION_PATCH}")
-		endif()
-	endif()
-endif()
-
 if(Git_FOUND)
 	if(MSVC)
 		execute_process(
@@ -129,8 +90,8 @@
     set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /guard:cf")
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /DYNAMICBASE")
     set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /DYNAMICBASE")
-    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /DYNAMICBASE")
-    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /guard:cf")
+    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${CMAKE_CXX_LINKER_WRAPPER_FLAG}/DYNAMICBASE")
+    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${CMAKE_CXX_LINKER_WRAPPER_FLAG}/guard:cf")
     # enable Spectre Mitigation, not supported by clang-cl
     if((NOT CMAKE_CXX_COMPILER_ID STREQUAL Clang) AND (NOT CMAKE_CXX_COMPILER_ID STREQUAL IntelLLVM))
         set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Qspectre")
@@ -179,10 +140,10 @@
 
     # enable creation of PDB files for Release Builds
     set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /Zi")
-    set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /DEBUG /OPT:REF /OPT:ICF")
+    set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} ${CMAKE_CXX_LINKER_WRAPPER_FLAG}/DEBUG ${CMAKE_CXX_LINKER_WRAPPER_FLAG}/OPT:REF ${CMAKE_CXX_LINKER_WRAPPER_FLAG}/OPT:ICF")
 
     # enable CET shadow stack
-    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /CETCOMPAT")
+    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${CMAKE_CXX_LINKER_WRAPPER_FLAG}/CETCOMPAT")
 
     #Use of sccache with MSVC requires workaround of replacing /Zi with /Z7
     #https://github.com/mozilla/sccache
@@ -316,3 +277,22 @@
 	)
 endif()
 
+if(CPACK_GENERATOR MATCHES "DEB")
+	string(FIND "${CMAKE_CXX_COMPILER}" "aarch64" compiler_arch_check)
+	if((NOT ${compiler_arch_check} MATCHES "-1") OR (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "aarch64"))
+		SET(CPACK_DEBIAN_PACKAGE_ARCHITECTURE arm64)
+	elseif(${CMAKE_SYSTEM_PROCESSOR} STREQUAL "x86_64")
+		SET(CPACK_DEBIAN_PACKAGE_ARCHITECTURE amd64)
+	endif()
+	set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/oneapi-src/level-zero")
+	set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
+	set(CPACK_DEBIAN_LEVEL-ZERO_PACKAGE_NAME "${PROJECT_NAME}")
+	set(CPACK_DEBIAN_LEVEL-ZERO-DEVEL_PACKAGE_NAME "${PROJECT_NAME}-devel")
+    set(CPACK_DEBIAN_LEVEL-ZERO_FILE_NAME "${PROJECT_NAME}_${PROJECT_VERSION}+${os_name}${os_version}_${CPACK_DEBIAN_PACKAGE_ARCHITECTURE}.deb")
+    set(CPACK_DEBIAN_LEVEL-ZERO-DEVEL_FILE_NAME "${PROJECT_NAME}-devel_${PROJECT_VERSION}+${os_name}${os_version}_${CPACK_DEBIAN_PACKAGE_ARCHITECTURE}.deb")
+    set(CPACK_DEBIAN_LEVEL-ZERO-DEVEL_PACKAGE_DEPENDS "level-zero(=${PROJECT_VERSION})")
+    set(CPACK_DEB_COMPONENT_INSTALL ON)
+    set(CPACK_ARCHIVE_COMPONENT_INSTALL ON)
+endif()
+
+INCLUDE(CPack)

=== source/utils/CMakeLists.txt ===
--- 
+++ 
@@ -7,6 +7,6 @@
 if(SYSTEM_SPDLOG)
        target_link_libraries(utils PUBLIC spdlog::spdlog)
 else()
-       target_include_directories(utils PUBLIC ${PROJECT_SOURCE_DIR}/third_party/spdlog_headers/)
+       target_include_directories(utils PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/third_party/spdlog_headers>)
 endif()
 set_property(TARGET utils PROPERTY POSITION_INDEPENDENT_CODE ON)

=== source/layers/validation/checkers/CMakeLists.txt ===
add_subdirectory(events_checker)
add_subdirectory(parameter_validation)
add_subdirectory(template)

=== debian/changelog ===
level-zero (1.19.2-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 17 Dec 2024 10:01:16 +0200
